<?php
new UPLIST();

//引数：y=年, md=月日


class UPLIST{
	private $savedir = 'd';
	
	function UPLIST(){
		error_reporting(0);
		$thisyear = date("Y", $_SERVER['REQUEST_TIME']);
		if(!$_GET['y']){ $_GET['y'] = $thisyear; }
		
		
		if(ctype_digit($_GET['y']) and ctype_digit($_GET['md']) and is_dir("$this->savedir/{$_GET['y']}/{$_GET['md']}")){
			$this->UploadFileList("$this->savedir/{$_GET['y']}/{$_GET['md']}");
		}
		elseif(ctype_digit($_GET['y']) and !$_GET['md'] and is_dir("$this->savedir/{$_GET['y']}")){
			$this->UploadDirList("$this->savedir/{$_GET['y']}");
		}
		elseif($_GET['y'] == $thisyear){
			$this->UploadDirList("$this->savedir/{$_GET['y']}");
		}
		else{
			$this->PrintError("パラメータが間違っています。");
		}
	}

	function UploadDirList($dirpath){
		$dh = opendir($dirpath);
		while ($dir = readdir($dh)){
			if(is_dir("$dirpath/$dir")){
				$dirlist[] = $dir;
			}
		}
	   	closedir($dh);
	   	sort($dirlist);
		
		$mlist = array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");
		$dlist = array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31");
		
		
		$caption = " {$_GET['y']}年 ";
		$backyear = $_GET['y'] - 1;
		$nextyear = $_GET['y'] + 1;
		if(is_dir("$this->savedir/$backyear")){ $caption  = "<a href=\"uplist.php?y={$backyear}\">←</a>{$caption}"; }
		if(is_dir("$this->savedir/$nextyear")){ $caption .= "<a href=\"uplist.php?y={$nextyear}\">→</a>"; }
		
		
		$table = "<table><caption>$caption</caption>\n";
		$table .= "<tr><th>1月</th><th>2月</th><th>3月</th><th>4月</th><th>5月</th><th>6月</th><th>7月</th><th>8月</th><th>9月</th><th>10月</th><th>11月</th><th>12月</th></tr>\n";
		foreach($dlist as $day){
			$table .= "<tr>";
			foreach($mlist as $month){
				if(in_array("$month$day", $dirlist)){
					$table .= "<td><a href=\"uplist.php?y={$_GET['y']}&md=$month$day\">{$month}月{$day}日</a></td>\n";
				}
				else{
					if($day == 29 and $month == "02"){
						if (($_GET['y'] % 4 == 0 && $_GET['y'] % 100 != 0) || $_GET['y'] % 400 == 0) { //うるう年
							$table .= "<td class=\"n\">{$month}月{$day}日</td>\n";
						}
						else{
							$table .= "<td class=\"n\">-</td>\n";
						}
					}
					elseif($day == 30 and $month == "02"){
						$table .= "<td class=\"n\">-</td>\n";
					}
					elseif($day == 31 and ($month == "02" or $month == "04" or $month == "06" or $month == "09" or $month == "11")){
						$table .= "<td class=\"n\">-</td>\n";
					}
					else{
						$table .= "<td class=\"n\">{$month}月{$day}日</td>\n";
					}
				}
			}
			$table .= "</tr>\n";
		}
		$table .= "</table>\n";
		$nav = "<nav><a href=\"upload.php\">アップローダ</a> / {$_GET['y']}年</nav>";
		$this->PrintResult("$nav$table");
	}


	function UploadFileList($dirpath){
		$dh = opendir($dirpath);
		while ($file = readdir($dh)){
			if(is_file("$dirpath/$file")){
				$filelist[] = $file;
			}
		}
	   	closedir($dh);
	   	sort($filelist);
		foreach($filelist as $file){
			if(preg_match("/^(\d+)/", $file, $matches)){
				$date = date("Y/m/d H:i", $matches[1]);
				$size = $this->ByteConvert(filesize("$dirpath/$file"));
				$tr .= "<tr><td>{$date}</td><td class=\"f\"><a href=\"$dirpath/$file\" target=\"_blank\">$file</a></td><td class=\"s\">$size</td></tr>\n";
			}
		}
		$y  = date("Y年", $matches[1]);
		$md = date("m月d日", $matches[1]);

		$nav = "<nav><a href=\"upload.php\">アップローダ</a> / <a href=\"uplist.php?y={$_GET['y']}\">{$_GET['y']}年</a> / $md</nav>";
		$this->PrintResult("$nav<table><caption>$y$md</caption><tr><th>投稿日</th><th>ファイル</th><th>サイズ</th></tr>\n{$tr}</table>\n");
	}


	function ByteConvert($byte){
		$byte = ceil($byte / 1024);
		if($byte >= 1024){
			$byte = round($byte / 1024) . ' MB';
		}
		else {
			$byte = $byte . ' KB';
		}
		return $byte;
	}

	function PrintResult($html){
		print <<<END_OF_LINE
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <title>アップリスト</title>
  <link href="style.css" rel="stylesheet">
</head>
<body id="uplist">
{$html}
</body>
</html>

END_OF_LINE;
		exit;
	}



	function PrintError($str){
		print <<<END_OF_LINE
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <title>アップリスト</title>
  <link href="style.css" rel="stylesheet">
</head>
<body>

<p class="error">$str</p>

<br><a href="uplist.php">アップリスト</a>
</body>
</html>

END_OF_LINE;
		exit;
	}

}


